summaryrefslogtreecommitdiffstats
path: root/target/default/target_skeleton
diff options
context:
space:
mode:
authormbm <mbm@3c298f89-4303-0410-b956-a3cf2f4a3e73>2005-05-30 09:09:58 +0000
committermbm <mbm@3c298f89-4303-0410-b956-a3cf2f4a3e73>2005-05-30 09:09:58 +0000
commit19a1490f400695cadb7b94fe70cde19d6c45bc8f (patch)
treedd2c97b19abc4292f9cd24b0af9f72e0c4af755f /target/default/target_skeleton
parent64caeb211dbae2b992463d484d6ddaae852b7de2 (diff)
make dnsmasq probe for dhcp servers before starting a dhcp server
git-svn-id: svn://svn.openwrt.org/openwrt/trunk/openwrt@1110 3c298f89-4303-0410-b956-a3cf2f4a3e73
Diffstat (limited to 'target/default/target_skeleton')
-rwxr-xr-xtarget/default/target_skeleton/etc/functions.sh28
-rwxr-xr-xtarget/default/target_skeleton/etc/init.d/S50dnsmasq25
-rwxr-xr-xtarget/default/target_skeleton/sbin/ifup8
3 files changed, 55 insertions, 6 deletions
diff --git a/target/default/target_skeleton/etc/functions.sh b/target/default/target_skeleton/etc/functions.sh
index 48f1191cc..60d6231f8 100755
--- a/target/default/target_skeleton/etc/functions.sh
+++ b/target/default/target_skeleton/etc/functions.sh
@@ -12,7 +12,7 @@ nvram () {
. /etc/nvram.overrides
# valid interface?
-if_valid () {
+if_valid () (
ifconfig "$1" >&- 2>&- ||
[ "${1%%[0-9]}" = "br" ] ||
{
@@ -29,5 +29,29 @@ if_valid () {
$DEBUG vconfig add $vif $i 2>&-
)
} ||
- { debug "# missing interface '$if' ignored"; false; }
+ { debug "# missing interface '$1' ignored"; false; }
+)
+
+bitcount () {
+ local c=$1
+ echo $((
+ c=((c>> 1)&0x55555555)+(c&0x55555555),
+ c=((c>> 2)&0x33333333)+(c&0x33333333),
+ c=((c>> 4)&0x0f0f0f0f)+(c&0x0f0f0f0f),
+ c=((c>> 8)&0x00ff00ff)+(c&0x00ff00ff),
+ c=((c>>16)&0x0000ffff)+(c&0x0000ffff)
+ ))
+}
+
+valid_netmask () {
+ return $((-($1)&~$1))
+}
+
+ip2int () (
+ set $(echo $1 | tr '\.' ' ')
+ echo $(($1<<24|$2<<16|$3<<8|$4))
+)
+
+int2ip () {
+ echo $(($1>>24&255)).$(($1>>16&255)).$(($1>>8&255)).$(($1&255))
}
diff --git a/target/default/target_skeleton/etc/init.d/S50dnsmasq b/target/default/target_skeleton/etc/init.d/S50dnsmasq
index 995c1b6e7..55bbc3719 100755
--- a/target/default/target_skeleton/etc/init.d/S50dnsmasq
+++ b/target/default/target_skeleton/etc/init.d/S50dnsmasq
@@ -1,2 +1,25 @@
#!/bin/sh
-/usr/sbin/dnsmasq
+. /etc/functions.sh
+
+# interface to use for DHCP
+iface=lan
+
+ifname=$(nvram get ${iface}_ifname)
+ipaddr=$(nvram get ${iface}_ipaddr)
+netmask=$(nvram get ${iface}_netmask)
+
+# check for existing DHCP server
+udhcpc -n -q -R -s /dev/zero -i $ifname >&- || {
+
+ ipaddr=$(ip2int $ipaddr)
+ netmask=$(ip2int ${netmask:-255.255.255.0})
+ network=$((ipaddr&netmask))
+
+ start=$(nvram get dhcp_start)
+ start=$((network+${start:-100}))
+ end=$(nvram get dhcp_num)
+ end=$((start+${end:-150}))
+
+ args="-K -F $(int2ip $start),$(int2ip $end),$(int2ip $netmask),12h"
+}
+/usr/sbin/dnsmasq ${args}
diff --git a/target/default/target_skeleton/sbin/ifup b/target/default/target_skeleton/sbin/ifup
index 9759f8d4d..60f9a1730 100755
--- a/target/default/target_skeleton/sbin/ifup
+++ b/target/default/target_skeleton/sbin/ifup
@@ -10,6 +10,7 @@
if_valid $if || return
+ mac=$(nvram get ${type}_hwaddr)
$DEBUG ifconfig $if down 2>&-
if [ "${if%%[0-9]}" = "br" ]; then
stp=$(nvram get ${type}_stp)
@@ -19,13 +20,14 @@
$DEBUG brctl stp $if ${stp:-0}
for sif in $(nvram get ${type}_ifnames); do {
if_valid $sif || continue
+ ${mac:+$DEBUG ifconfig $sif down hw ether $mac}
$DEBUG ifconfig $sif 0.0.0.0 up
$DEBUG brctl addif $if $sif
} done
+ else
+ ${mac:+$DEBUG ifconfig $if down hw ether $mac}
fi
- mac=$(nvram get ${type}_hwaddr)
- ${mac:+$DEBUG ifconfig $if hw ether $mac}
if_proto=$(nvram get ${type}_proto)
case "$if_proto" in
@@ -50,7 +52,7 @@
if [ -f $pidfile ]; then
$DEBUG kill $(cat $pidfile)
fi
- ${DEBUG:-eval} "udhcpc -i $if ${ip:+-r $ip} -b -p $pidfile &"
+ ${DEBUG:-eval} "udhcpc -R -i $if ${ip:+-r $ip} -b -p $pidfile &"
;;
none|"")
# pppoe is handled by /etc/init.d/S50pppoe